;Colorblast - Six of DLoC 2004

	processor 6502
	org $0801
BASIC
	dc.b $0c,$08,$06,$00,$9e,$20,$32,$30
	dc.b $36,$34,$00,$00,$00,$00,$00
	
START
	lda #$00
	sta $d020
	sta $d021
	jsr $e544	
	jsr Menable
	jsr SetupDMA
	jsr SetupIRQ
LOOP	
	jmp LOOP
Menable
	lda #$01
	sta $d03f ;Enable Extended VIC Features
	rts
SetupDMA	
	lda #<CTAB
	sta $d300
	lda #>CTAB
	sta $d301
	lda #$40
	sta $d302 ;Address to blit from is RAM:CTAB

	lda #$00
	sta $d303
	lda #$d2
	sta $d304
	lda #$80
	sta $d305 ;Address to blit to is REGISTER:d200 (palette entry 0)
	
	lda #$00
	sta $d307
	sta $d309 ;Clear high bits of source and dest step.
	lda #$01
	sta $d306 ;Source Step is 1 byte
	lda #$00
	sta $d308 ;Dest Step is 0 byte
	
	lda #$88
	sta $d30a
	lda #$01
	sta $d30b ;We're blasting $0188 bytes into palette entry 0
	
	sta $d30c
	sta $d30d
	sta $d30e
	sta $d30f
	sta $d310
	sta $d311
	sta $d312
	sta $d313
	sta $d31e;Not using line length or modulo in this example.
	rts
SetupIRQ
	sei
	inc $d019
	inc $d01a
	lda #$7f
	sta $dc0d
	lda #$1b
	sta $d011
	lda #$51
	sta $d012
	lda #<IRQ
	sta $0314
	lda #>IRQ
	sta $0315
	cli
	rts

IRQ	;Note - I've tested this with sprites.  They have virtually no effect
        ;on the DMA colorbar.

	inc $d019; You know, I could to a bunch of crazy stuff on this IRQ.
	
	lda #$51 ; Tell VIC when to trigger my next VIC IRQ
	sta $d012
	
	lda #$1d
	sta $d31f ; Tell the DMA to trigger on my next VIC IRQ.
	jmp $ea31



CTAB
	;I did a transition that doesn't really show the effect off too much, 

	dc.b $04,$14,$24,$34,$44,$54,$64,$74
	dc.b $84,$94,$a4,$b4,$c4,$a4,$94,$84
	dc.b $74,$64,$54,$44,$34,$24,$14,$04
	
	dc.b $05,$15,$25,$35,$45,$55,$65,$75
	dc.b $85,$95,$a5,$b5,$c5,$a5,$95,$85
	dc.b $75,$65,$55,$45,$35,$25,$15,$05
	
	dc.b $06,$16,$26,$36,$46,$56,$66,$76
	dc.b $86,$96,$a6,$b6,$c6,$a6,$96,$86 
	dc.b $76,$66,$56,$46,$36,$26,$16,$06
	
	dc.b $07,$17,$27,$37,$47,$57,$67,$77
	dc.b $87,$97,$a7,$b7,$c7,$a7,$97,$87
	dc.b $77,$67,$57,$47,$37,$27,$17,$07
	
	dc.b $08,$18,$28,$38,$48,$58,$68,$78
	dc.b $88,$98,$a8,$b8,$c8,$a8,$98,$88
	dc.b $78,$68,$58,$48,$38,$28,$18,$08
	
	dc.b $09,$19,$29,$39,$49,$59,$69,$79
	dc.b $89,$99,$a9,$b9,$c9,$a9,$99,$89
	dc.b $79,$69,$59,$49,$39,$29,$19,$09
	
	dc.b $0a,$1a,$2a,$3a,$4a,$5a,$6a,$7a
	dc.b $8a,$9a,$aa,$ba,$ca,$aa,$9a,$8a
	dc.b $7a,$6a,$5a,$4a,$3a,$2a,$1a,$0a
	
	dc.b $0b,$1b,$2b,$3b,$4b,$5b,$6b,$7b
	dc.b $8b,$9b,$ab,$bb,$cb,$ab,$9b,$8b
	dc.b $7b,$6b,$5b,$4b,$3b,$2b,$1b,$0b
	 

	dc.b $0b,$1b,$2b,$3b,$4b,$5b,$6b,$7b
	dc.b $8b,$9b,$ab,$bb,$cb,$ab,$9b,$8b
	dc.b $7b,$6b,$5b,$4b,$3b,$2b,$1b,$0b

	dc.b $0a,$1a,$2a,$3a,$4a,$5a,$6a,$7a
	dc.b $8a,$9a,$aa,$ba,$ca,$aa,$9a,$8a
	dc.b $7a,$6a,$5a,$4a,$3a,$2a,$1a,$0a

	dc.b $09,$19,$29,$39,$49,$59,$69,$79
	dc.b $89,$99,$a9,$b9,$c9,$a9,$99,$89
	dc.b $79,$69,$59,$49,$39,$29,$19,$09

	dc.b $08,$18,$28,$38,$48,$58,$68,$78
	dc.b $88,$98,$a8,$b8,$c8,$a8,$98,$88
	dc.b $78,$68,$58,$48,$38,$28,$18,$08

	dc.b $07,$17,$27,$37,$47,$57,$67,$77
	dc.b $87,$97,$a7,$b7,$c7,$a7,$97,$87
	dc.b $77,$67,$57,$47,$37,$27,$17,$07

	dc.b $06,$16,$26,$36,$46,$56,$66,$76
	dc.b $86,$96,$a6,$b6,$c6,$a6,$96,$86 
	dc.b $76,$66,$56,$46,$36,$26,$16,$06

	dc.b $05,$15,$25,$35,$45,$55,$65,$75
	dc.b $85,$95,$a5,$b5,$c5,$a5,$95,$85
	dc.b $75,$65,$55,$45,$35,$25,$15,$05

	dc.b $04,$14,$24,$34,$44,$54,$64,$74
	dc.b $84,$94,$a4,$b4,$c4,$a4,$94,$84
	dc.b $74,$64,$54,$44,$34,$24,$14,$04

	dc.b $00,$00,$00,$00,$00,$00,$00,$00
